Index: /java/main/src/main/java/com/framsticks/hosting/InstanceClient.java
===================================================================
--- /java/main/src/main/java/com/framsticks/hosting/InstanceClient.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/hosting/InstanceClient.java	(revision 96)
@@ -1,13 +1,19 @@
 package com.framsticks.hosting;
+
+import static com.framsticks.util.lang.Strings.assureNotEmpty;
 
 import com.framsticks.communication.*;
 import com.framsticks.communication.queries.ApplicationRequest;
+import com.framsticks.communication.queries.CallRequest;
 import com.framsticks.communication.queries.GetRequest;
 import com.framsticks.communication.queries.InfoRequest;
+import com.framsticks.communication.queries.SetRequest;
 import com.framsticks.core.Instance;
+import com.framsticks.core.InstanceUtils;
 import com.framsticks.core.Path;
 import com.framsticks.params.*;
+import com.framsticks.params.types.ProcedureParam;
 import com.framsticks.parsers.Savers;
-import com.framsticks.core.LocalInstance;
+import com.framsticks.util.FramsticksException;
 import com.framsticks.util.dispatching.AbstractJoinable;
 import com.framsticks.util.dispatching.Dispatching;
@@ -16,10 +22,9 @@
 import com.framsticks.util.dispatching.JoinableParent;
 import com.framsticks.util.dispatching.JoinableState;
+import static com.framsticks.core.InstanceUtils.*;
 
 import java.net.Socket;
-import java.util.ArrayList;
 import java.util.LinkedList;
 import java.util.List;
-import com.framsticks.util.dispatching.RunAt;
 
 /**
@@ -28,43 +33,55 @@
 public class InstanceClient extends AbstractJoinable implements RequestHandler, JoinableParent {
 
-	protected final LocalInstance instance;
+	protected final Server server;
+	protected final Instance instance;
 	protected final ServerConnection connection;
 
-	public InstanceClient(LocalInstance instance, Socket socket) {
-		this.instance = instance;
-		connection = new ServerConnection(socket, this);
+	public InstanceClient(Server server, Socket socket) {
+		this.server = server;
+		this.instance = server.hosted;
+		this.connection = new ServerConnection(socket, this);
 	}
 
 	@Override
-	public String toString() {
-		return instance + "|" + connection.toString();
+	public String getName() {
+		return connection + " to " + server;
 	}
 
 	@Override
 	public void handle(final ApplicationRequest request, final ResponseCallback<?> responseCallback) {
-		instance.dispatch(new RunAt<Instance>() {
+		assureNotEmpty(request.getPath());
+
+		resolve(instance, request.getPath(), new Future<Path>(responseCallback) {
 			@Override
-			public void run() {
-				final Path path = instance.getPath(request.getPath());
-				if (!path.isResolved(request.getPath())) {
-					responseCallback.process(new Response(false, "\"invalid path\"", null));
+			protected void result(final Path path) {
+
+				// final AccessInterface access = instance.prepareAccess(path);
+				final AccessInterface access = instance.prepareAccess(path.getTop().getParam());
+
+				if (request instanceof SetRequest) {
+					SetRequest set = (SetRequest) request;
+					//TODO Proxy - here is break of chain, instance should have hosted
+					//hosted set
+					AccessInterface access2 = InstanceUtils.bindAccess(path);
+					int flag = access2.set(set.getField(), set.getValue());
+
+					responseCallback.process(new Response(true, Flags.write(flag, null), null));
 					return;
 				}
+
 				if (request instanceof GetRequest) {
-					instance.findInfo(path, new Future<FramsClass>() {
+					InstanceUtils.findInfo(path, new Future<FramsClass>(responseCallback) {
 						@Override
-						public void result(FramsClass result, Exception e) {
+						protected void result(FramsClass result) {
 							if (result == null) {
-								responseCallback.process(new Response(false, "\"failed to find info for access bind\"", null));
-								return;
+								throw new FramsticksException().msg("failed to find info for access bind");
 							}
 							List<File> files = new LinkedList<File>();
-							AccessInterface access = instance.bindAccess(path);
+							AccessInterface access = bindAccess(path);
 
 							if (access == null) {
+								throw new FramsticksException().msg("failed to bind access");
+							}
 
-								responseCallback.process(new Response(false, "\"failed to bind access\"", null));
-								return;
-							}
 							ListSink sink = new ListSink();
 							access.save(sink);
@@ -75,22 +92,36 @@
 					return;
 				}
-				if (request instanceof InfoRequest) {
-					instance.findInfo(path, new Future<FramsClass>() {
+				if (request instanceof CallRequest) {
+					final CallRequest callRequest = (CallRequest) request;
+					instance.call(path, access.getFramsClass().getParamEntry(callRequest.getProcedure(), ProcedureParam.class), callRequest.getArguments().toArray(), new Future<Object>(responseCallback) {
 						@Override
-						public void result(FramsClass result, Exception e) {
-							if (result == null) {
-								responseCallback.process(new Response(false, "\"info not found\"", null));
-								return;
+						protected void result(Object result) {
+							ListSink sink = new ListSink();
+							sink.print("Result:").breakLine();
+							sink.print("value:").print("[");
+							if (result != null) {
+								sink.print(result);
 							}
-							ListSink sink = new ListSink();
-							Savers.saveFramsClass(sink, result);
-							List<File> files = new ArrayList<File>();
-							files.add(new File(path.getTextual(), new ListSource(sink.getOut())));
-							responseCallback.process(new Response(true, null, files));
+							sink.print("]");
+
+							responseCallback.process(new Response(true, "", File.single(new File("", new ListSource(sink.getOut())))));
 						}
 					});
 					return;
 				}
-				responseCallback.process(new Response(false, "invalid", null));
+				if (request instanceof InfoRequest) {
+					findInfo(path, new Future<FramsClass>(responseCallback) {
+						@Override
+						protected void result(FramsClass result) {
+							if (result == null) {
+								throw new FramsticksException().msg("info not found");
+							}
+							responseCallback.process(new Response(true, null, File.single(new File(path.getTextual(), new ListSource(Savers.saveFramsClass(new ListSink(), result).getOut())))));
+						}
+					});
+					return;
+				}
+
+				throw new FramsticksException().msg("invalid request type: " + request.getCommand());
 			}
 		});
@@ -122,3 +153,4 @@
 	}
 
+
 }
Index: /java/main/src/main/java/com/framsticks/hosting/Server.java
===================================================================
--- /java/main/src/main/java/com/framsticks/hosting/Server.java	(revision 96)
+++ /java/main/src/main/java/com/framsticks/hosting/Server.java	(revision 96)
@@ -0,0 +1,220 @@
+package com.framsticks.hosting;
+
+import org.apache.log4j.Level;
+import org.apache.log4j.Logger;
+
+import com.framsticks.core.Instance;
+import com.framsticks.params.annotations.AutoAppendAnnotation;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.dispatching.AbstractJoinable;
+import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.Joinable;
+import com.framsticks.util.dispatching.JoinableCollection;
+import com.framsticks.util.dispatching.JoinableParent;
+import com.framsticks.util.dispatching.JoinableState;
+import com.framsticks.util.dispatching.RunAt;
+import com.framsticks.util.dispatching.Task;
+
+import java.io.IOException;
+import java.net.InetSocketAddress;
+import java.net.ServerSocket;
+import java.net.Socket;
+import com.framsticks.util.dispatching.Thread;
+
+@FramsClassAnnotation
+public class Server extends AbstractJoinable implements JoinableParent {
+
+	private final static Logger log = Logger.getLogger(Server.class);
+
+	protected int port;
+
+	protected ServerSocket acceptSocket;
+	protected Instance hosted;
+	protected final JoinableCollection<InstanceClient> clients = new JoinableCollection<InstanceClient>();
+
+	public static class Accept {
+	};
+
+	protected Thread<Accept> acceptThread = new Thread<>();
+
+	/**
+	 *
+	 */
+	public Server() {
+		log.debug("created server");
+		port = 9009;
+	}
+
+	/**
+	 * @return the port
+	 */
+	@ParamAnnotation
+	public int getPort() {
+		return port;
+	}
+
+	/**
+	 * @param port the port to set
+	 */
+	@ParamAnnotation
+	public void setPort(int port) {
+		this.port = port;
+	}
+
+	@Override
+	protected void joinableInterrupt() {
+		Dispatching.drop(acceptThread, this);
+		Dispatching.drop(hosted, this);
+		Dispatching.drop(clients, this);
+		try {
+			acceptSocket.close();
+		} catch (IOException e) {
+			log.debug("exception caught during socket closing: ", e);
+		}
+		finish();
+	}
+
+	/**
+	 * @return the hosted
+	 */
+	public Instance getHosted() {
+		return hosted;
+	}
+
+	@AutoAppendAnnotation
+	public void setHosted(Instance hosted) {
+		if (this.hosted != null) {
+			throw new FramsticksException().msg("hosted instance is already set").arg("current", this.hosted);
+		}
+		this.hosted = hosted;
+		acceptThread.setName(hosted.getName() + " acceptor");
+		clients.setObservableName(hosted.getName() + " clients");
+	}
+
+	@Override
+	public void childChangedState(Joinable joinable, JoinableState state) {
+		proceedToState(state);
+	}
+
+	@Override
+	protected void joinableStart() {
+		Dispatching.use(acceptThread, this);
+		Dispatching.use(hosted, this);
+		Dispatching.use(clients, this);
+		try {
+			acceptSocket = new ServerSocket();
+		} catch (IOException e) {
+			throw new FramsticksException().msg("failed to create server socket").cause(e);
+		}
+		tryBind(0);
+	}
+
+	@Override
+	@ParamAnnotation
+	public String getName() {
+		return hosted != null ? hosted.getName() : "server";
+	}
+
+	protected void acceptNext() {
+		if (!isRunning()) {
+			log.debug("server is not in running state, aborting accepting");
+			return;
+		}
+		acceptThread.dispatch(new RunAt<Accept>() {
+			@Override
+			public void run() {
+				try {
+					log.debug("accepting");
+					final Socket socket = acceptSocket.accept();
+					assert socket != null;
+					log.debug("accepted socket: " + socket.getInetAddress().getHostAddress());
+					hosted.dispatch(new RunAt<Instance>() {
+						@Override
+						public void run() {
+							InstanceClient client = new InstanceClient(Server.this, socket);
+							clients.add(client);
+							log.info("client connected: " + client);
+						}
+					});
+				} catch (IOException e) {
+					log.log((isRunning() ? Level.ERROR : Level.DEBUG), "failed to accept socket: " + e);
+				}
+				acceptNext();
+			}
+		});
+	}
+
+	protected void tryBind(int when) {
+		acceptThread.dispatch(new Task<Accept>(when) {
+			@Override
+			public void run() {
+				try {
+					acceptSocket.bind(new InetSocketAddress(port));
+					log.debug("started accepting on port " + port);
+					acceptNext();
+					return;
+				} catch (IOException e) {
+					log.warn("failed to accept on port " + port + " (repeating): " + e);
+				}
+				tryBind(1000);
+			}
+		});
+	}
+
+	@Override
+	protected void joinableFinish() {
+
+	}
+
+	@Override
+	protected void joinableJoin() throws InterruptedException {
+		Dispatching.join(acceptThread);
+		Dispatching.join(hosted);
+		Dispatching.join(clients);
+	}
+
+	// @Override
+	// public FramsClass getInfoFromCache(String id) {
+	//	assert isActive();
+	//	if (id == null) {
+	//		return null;
+	//	}
+	//	FramsClass cached = registry.getFramsClass(id);
+	//	if (cached != null) {
+	//		return cached;
+	//	}
+	//	try {
+	//		Class<?> nativeClass = Class.forName(id);
+	//		FramsClass framsClass = FramsClass.build().forClass(nativeClass);
+
+	//		if (!framsClass.getId().equals(id)) {
+	//			log.error("no matching id");
+	//			return null;
+	//		}
+
+	//		registry.registerReflectedClass(null, id, nativeClass);
+	//		registry.putFramsClass(framsClass);
+	//		return framsClass;
+	//	} catch (ClassNotFoundException ignored) {
+	//	} catch (ConstructionException e) {
+	//		log.error("failed to use info from cache: " + e);
+	//	}
+
+	//	return null;
+	// }
+
+	// @Override
+	// protected void fetchInfo(Path path, Future<FramsClass> future) {
+	//	assert isActive();
+
+	//	FramsClass framsClass = getInfoFromCache(path.getTop().getObject().getClass().getCanonicalName());
+	//	if (framsClass == null) {
+	//		log.error("failed to create frams class for: " + path.getTop().getObject().getClass());
+	//		future.result(null, new Exception());
+	//		return;
+	//	}
+	//	future.result(framsClass, null);
+	// }
+}
Index: /java/main/src/main/java/com/framsticks/params/AccessInterface.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/AccessInterface.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/params/AccessInterface.java	(revision 96)
@@ -75,5 +75,5 @@
 	FramsClass getFramsClass();
 
-	boolean tryAutoAppend(Object object);
+	void tryAutoAppend(Object object);
 
 
Index: /java/main/src/main/java/com/framsticks/params/Flags.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/Flags.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/params/Flags.java	(revision 96)
@@ -50,5 +50,5 @@
 
 	public static String write(int flags, String empty) {
-		Delimeted d = new Delimeted("+", empty);
+		Delimeted<String> d = new Delimeted<String>("+", empty);
 		try {
 			for (Field f : Flags.class.getDeclaredFields()) {
Index: /java/main/src/main/java/com/framsticks/params/FramsClass.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/FramsClass.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/params/FramsClass.java	(revision 96)
@@ -130,5 +130,5 @@
 	}
 
-	public <T extends Param> T castedParam(@Nonnull final Param param, @Nonnull final Class<T> type, Object name) {
+	public @Nonnull <T extends Param> T castedParam(@Nonnull final Param param, @Nonnull final Class<T> type, Object name) {
 		if (param == null) {
 			// return null;
@@ -149,5 +149,5 @@
 	 * @return the param entry
 	 */
-	public <T extends Param> T getParamEntry(final int i, @Nonnull final Class<T> type) {
+	public @Nonnull <T extends Param> T getParamEntry(final int i, @Nonnull final Class<T> type) {
 		return castedParam(getParam(i), type, i);
 	}
@@ -160,5 +160,5 @@
 	 * @return the param entry
 	 */
-	public <T extends Param> T getParamEntry(@Nonnull final String id, @Nonnull final Class<T> type) {
+	public @Nonnull <T extends Param> T getParamEntry(@Nonnull final String id, @Nonnull final Class<T> type) {
 		return castedParam(getParam(id), type, id);
 	}
Index: /java/main/src/main/java/com/framsticks/params/FramsClassBuilder.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/FramsClassBuilder.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/params/FramsClassBuilder.java	(revision 96)
@@ -22,4 +22,5 @@
 import com.framsticks.parsers.Loaders;
 import com.framsticks.util.Builder;
+import com.framsticks.util.Misc;
 import com.framsticks.util.lang.Containers;
 import com.framsticks.util.lang.Strings;
@@ -78,13 +79,13 @@
 			// TODO: future support for enum
 			// if (cl.isEnum()) {
-			// 	Class<? extends Enum<?>> enumType = (Class<? extends Enum<?>>) cl;
-			// 	Enum<?>[] enums = enumType.getEnumConstants();
-			// 	StringBuilder b = new StringBuilder();
-
-			// 	b.append("d 0 ").append(enums.length - 1).append(" 0 ");
-			// 	for (Enum<?> e : enums) {
-			// 		b.append("~").append(e.name());
-			// 	}
-			// 	return b.toString();
+			//	Class<? extends Enum<?>> enumType = (Class<? extends Enum<?>>) cl;
+			//	Enum<?>[] enums = enumType.getEnumConstants();
+			//	StringBuilder b = new StringBuilder();
+
+			//	b.append("d 0 ").append(enums.length - 1).append(" 0 ");
+			//	for (Enum<?> e : enums) {
+			//		b.append("~").append(e.name());
+			//	}
+			//	return b.toString();
 			// }
 			if (cl.equals(Integer.class) || cl.equals(int.class)) {
@@ -125,5 +126,7 @@
 		}
 
-		builder.resultType(induceParamType(Param.build(), method.getGenericReturnType()).finish(ValueParam.class));
+		if (!method.getReturnType().equals(Void.TYPE)) {
+			builder.resultType(induceParamType(Param.build(), method.getGenericReturnType()).finish(ValueParam.class));
+		}
 
 		List<ValueParam> arguments = new ArrayList<>();
@@ -337,4 +340,8 @@
 	}
 
+	@Override
+	public String toString() {
+		return "FramsClassBuilder for " + Misc.returnNotNull(id, "<not yet known>");
+	}
 
 }
Index: /java/main/src/main/java/com/framsticks/params/ListAccess.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/ListAccess.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/params/ListAccess.java	(revision 96)
@@ -79,6 +79,6 @@
 	//TODO it could actually be used also
 	@Override
-	public boolean tryAutoAppend(Object object) {
-		return false;
+	public void tryAutoAppend(Object object) {
+		throw new InvalidOperationException();
 	}
 
Index: /java/main/src/main/java/com/framsticks/params/Param.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/Param.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/params/Param.java	(revision 96)
@@ -17,5 +17,5 @@
  */
 @Immutable
-@FramsClassAnnotation(id = "prop", name = "prop")
+@FramsClassAnnotation(id = "prop", name = "prop", order = {"id", "name", "type", "flags", "help", "group", "extra"})
 public abstract class Param {
 
@@ -33,9 +33,9 @@
 
 	/** The getFlags stored as a bit sum. */
-	protected final Integer flags;
+	protected final int flags;
 
 	//TODO
 	/** The variable determining whether the parameter is an extra parameter. */
-	protected final Integer extra;
+	protected final int extra;
 
 	public Param(ParamBuilder builder) {
@@ -68,9 +68,10 @@
 	}
 
-	@ParamAnnotation
+	@ParamAnnotation(def = "0")
 	public Integer getFlags() {
 		return flags;
 	}
 
+	@ParamAnnotation(id = "type")
 	public abstract String getFramsTypeName();
 
@@ -92,5 +93,5 @@
 
 	public boolean hasFlag(int flag) {
-		return flags != null && (flags & flag) != 0;
+		return (flags & flag) != 0;
 	}
 
Index: /java/main/src/main/java/com/framsticks/params/ParamBuilder.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/ParamBuilder.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/params/ParamBuilder.java	(revision 96)
@@ -6,4 +6,5 @@
 import com.framsticks.util.Builder;
 import com.framsticks.util.FramsticksException;
+import com.framsticks.util.Misc;
 import com.framsticks.util.lang.Strings;
 
@@ -46,5 +47,5 @@
 
 	/** The flags stored as a bit sum. */
-	private Integer flags = 0;
+	private int flags = 0;
 
 	/** The parameter name. */
@@ -63,5 +64,5 @@
 	private Object def;
 
-	private Integer extra;
+	private int extra = 0;
 
 	String containedTypeName;
@@ -179,5 +180,5 @@
 		try {
 			if (paramType == null) {
-				throw new FramsticksException().msg("trying to finish incomplete param");
+				throw new FramsticksException().msg("trying to finish incomplete param while type is missing");
 			}
 			return paramType.getConstructor(ParamBuilder.class).newInstance(this);
@@ -214,5 +215,5 @@
 
 	@ParamAnnotation
-	public ParamBuilder flags(Integer flags) {
+	public ParamBuilder flags(int flags) {
 		this.flags = flags;
 		return this;
@@ -359,5 +360,5 @@
 	 */
 	@ParamAnnotation
-	public Integer getFlags() {
+	public int getFlags() {
 		return flags;
 	}
@@ -385,5 +386,5 @@
 
 	@ParamAnnotation(id = "xtra")
-	public Integer getExtra() {
+	public int getExtra() {
 		return extra;
 	}
@@ -397,5 +398,5 @@
 
 	@ParamAnnotation(id = "xtra")
-	public ParamBuilder extra(Integer extra) {
+	public ParamBuilder extra(int extra) {
 		this.extra = extra;
 		return this;
@@ -517,5 +518,9 @@
 		}
 		String result = Strings.collapse(matcher.group(1));
-		resultType = (result != null) ? parseProcedureTypePart(result, null) : null;
+		if (result != null) {
+			resultType = Param.build().type(result).finish(ValueParam.class);
+		} else {
+			resultType = null;
+		}
 		String arguments = matcher.group(2);
 		if (!Strings.notEmpty(arguments)) {
@@ -524,15 +529,14 @@
 		int number = 0;
 		for (String a : arguments.split(",")) {
+			ParamBuilder arg = Param.build();
+
 			int space = a.indexOf(' ');
-			String type;
-			String name;
 			if (space == -1) {
-				type = a;
-				name = "arg" + number;
+				arg.type(a).id("arg" + number);
 			} else {
-				type = a.substring(0, space);
-				name = a.substring(space + 1);
-			}
-			argumentsType.add(parseProcedureTypePart(type, name));
+				String name = a.substring(space + 1);
+				arg.type(a.substring(0, space)).id(name).name(name);
+			}
+			argumentsType.add(arg.finish(ValueParam.class));
 			++number;
 		}
@@ -546,4 +550,9 @@
 		return this;
 	}
+
+	@Override
+	public String toString() {
+		return "ParamBuilder for " + Misc.returnNotNull(id, "<not yet known>");
+	}
 }
 
Index: /java/main/src/main/java/com/framsticks/params/PropertiesAccess.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/PropertiesAccess.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/params/PropertiesAccess.java	(revision 96)
@@ -91,6 +91,6 @@
 
 	@Override
-	public boolean tryAutoAppend(Object object) {
-		return false;
+	public void tryAutoAppend(Object object) {
+		throw new InvalidOperationException();
 	}
 
Index: /java/main/src/main/java/com/framsticks/params/ReflectionAccess.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/ReflectionAccess.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/params/ReflectionAccess.java	(revision 96)
@@ -378,18 +378,23 @@
 
 	@Override
-	public boolean tryAutoAppend(Object value) {
+	public void tryAutoAppend(Object value) {
 		assert object != null;
-		for (Method m : backend.autoAppendMethods) {
-			if (m.getParameterTypes()[0].isAssignableFrom(value.getClass())) {
-				try {
-					log.trace("auto appending with value " + value + " with method " + m);
-					m.invoke(object, value);
-					return true;
-				} catch (IllegalAccessException | IllegalArgumentException | InvocationTargetException | FramsticksException e) {
-					throw new FramsticksException().msg("failed to auto append").cause(e).arg("value", value).arg("into object", object).arg("with method", m);
-				}
-			}
-		}
-		return false;
+		try {
+			for (Method m : backend.autoAppendMethods) {
+				if (m.getParameterTypes()[0].isAssignableFrom(value.getClass())) {
+					try {
+						log.trace("auto appending with value " + value + " with method " + m);
+						m.invoke(object, value);
+						return;
+					} catch (IllegalAccessException | IllegalArgumentException | InvocationTargetException | FramsticksException e) {
+						throw new FramsticksException().msg("failed to auto append").cause(e).arg("with method", m);
+					}
+				}
+			}
+			throw new FramsticksException().msg("no method found to append");
+		} catch (FramsticksException e) {
+			throw e.arg("value", value).arg("into object", object);
+		}
+
 	}
 
Index: /java/main/src/main/java/com/framsticks/params/Registry.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/Registry.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/params/Registry.java	(revision 96)
@@ -46,4 +46,11 @@
 		associate(javaClass, putFramsClass(FramsClass.build().forClass(javaClass)));
 		return this;
+	}
+
+	public FramsClass registerReflectedIfNeeded(Class<?> javaClass) {
+		if (!javaToFramsAssociation.containsKey(javaClass)) {
+			registerAndBuild(javaClass);
+		}
+		return javaToFramsAssociation.get(javaClass);
 	}
 
Index: /java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java	(revision 96)
@@ -7,4 +7,6 @@
 
 import org.apache.log4j.Logger;
+
+import com.framsticks.util.UnimplementedException;
 
 /**
@@ -177,5 +179,6 @@
 	@Override
 	public void copyFrom(AccessInterface src) {
-		clearValues();
+		throw new UnimplementedException();
+		// clearValues();
 		//TODO: iterate over self, and pull from src
 		/*
@@ -185,7 +188,4 @@
 		*/
 	}
-
-
-
 
 	@Override
@@ -195,5 +195,5 @@
 		for (PrimitiveParam<?> p : filterInstanceof(framsClass.getParamEntries(), PrimitiveParam.class)) {
 			Object value = get(p, Object.class);
-			if (value == null) {
+			if ((value == null) || value.equals(p.getDef(Object.class))) {
 				continue;
 			}
Index: /java/main/src/main/java/com/framsticks/params/types/ProcedureParam.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/types/ProcedureParam.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/params/types/ProcedureParam.java	(revision 96)
@@ -7,4 +7,5 @@
 import java.util.List;
 
+import javax.annotation.Nullable;
 import javax.annotation.concurrent.Immutable;
 
@@ -16,4 +17,5 @@
 	private final ValueParam resultType;
 	private final List<ValueParam> argumentsType;
+	private final String signatureString;
 
 	/**
@@ -24,4 +26,27 @@
 		resultType = builder.getResultType();
 		argumentsType = builder.getArgumentsType();
+
+		StringBuilder b = new StringBuilder().append("p");
+
+		if (resultType != null) {
+			b.append(" ").append(resultType.getFramsTypeName());
+		}
+		b.append("(");
+		boolean first = true;
+		for (ValueParam arg : argumentsType) {
+			if (first) {
+				first = false;
+			} else {
+				b.append(", ");
+			}
+
+			b.append(arg.getFramsTypeName());
+			if (arg.getName() != null) {
+				b.append(" ").append(arg.getName());
+			}
+		}
+		b.append(")");
+
+		signatureString = b.toString();
 		assert argumentsType != null;
 	}
@@ -32,5 +57,5 @@
 	}
 
-	public ValueParam getResultType() {
+	public @Nullable ValueParam getResultType() {
 		return resultType;
 	}
@@ -42,5 +67,5 @@
 	@Override
 	public String getFramsTypeName() {
-		return "p";
+		return signatureString;
 	}
 
Index: /java/main/src/main/java/com/framsticks/parsers/Loaders.java
===================================================================
--- /java/main/src/main/java/com/framsticks/parsers/Loaders.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/parsers/Loaders.java	(revision 96)
@@ -32,8 +32,6 @@
 					return;
 				}
-				if (framsClassAccess.select(builder).tryAutoAppend(object)) {
-					return;
-				}
-				throw new ConstructionException().msg("failed to interpretate object").arg("object", object);
+				framsClassAccess.select(builder).tryAutoAppend(object);
+				// throw new ConstructionException().msg("failed to interpretate object").arg("object", object);
 
 			}
Index: /java/main/src/main/java/com/framsticks/parsers/Savers.java
===================================================================
--- /java/main/src/main/java/com/framsticks/parsers/Savers.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/parsers/Savers.java	(revision 96)
@@ -8,5 +8,5 @@
  */
 public class Savers {
-	public static void saveFramsClass(SinkInterface sink, FramsClass framsClass) {
+	public static <S extends SinkInterface> S saveFramsClass(S sink, FramsClass framsClass) {
 
 		AccessInterface framsClassAccess = new ReflectionAccess(FramsClass.class);
@@ -18,4 +18,5 @@
 			paramAccess.save(sink);
 		}
+		return sink;
 	}
 
Index: /java/main/src/main/java/com/framsticks/parsers/XmlLoader.java
===================================================================
--- /java/main/src/main/java/com/framsticks/parsers/XmlLoader.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/parsers/XmlLoader.java	(revision 96)
@@ -98,7 +98,5 @@
 
 			for (Object child : childrenObjects) {
-				if (!access.tryAutoAppend(child)) {
-					throw new FramsticksException().msg("failed to auto append").arg("child", child).arg("parent", object);
-				}
+				access.tryAutoAppend(child);
 			}
 		}
Index: /java/main/src/main/java/com/framsticks/portals/Portal.java
===================================================================
--- /java/main/src/main/java/com/framsticks/portals/Portal.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/portals/Portal.java	(revision 96)
@@ -4,4 +4,5 @@
 import com.framsticks.core.AbstractInstanceListener;
 import com.framsticks.core.Instance;
+import com.framsticks.core.InstanceUtils;
 import com.framsticks.core.Path;
 import com.framsticks.params.annotations.FramsClassAnnotation;
@@ -61,8 +62,8 @@
 					@Override
 					public void run() {
-						instance.resolve(path, new Future<Path>() {
+						InstanceUtils.resolve(instance, path, new Future<Path>(Logging.logger(log, "resolve", path)) {
 							@Override
-							public void result(Path result, Exception e) {
-								Logging.log(log, "resolve", path, e);
+							public void result(Path result) {
+								Logging.log(log, "resolve", path, null);
 							}
 						});
